<template>
    <div>
        <v-card elevation="1" class="admin-content">
            <v-card-title>
                {{title ? title : 'Liste des cabinets'}}
                <v-divider class="ml-4 mr-2" inset vertical></v-divider>
                <v-col cols="12" md="4">
                    <v-text-field
                        v-model="search"
                        append-icon="mdi-magnify"
                        label="Rechercher un cabinet"
                        single-line
                        hide-details
                    />
                </v-col>
                <v-divider class="ml-4 mr-6" inset vertical></v-divider>
                <v-btn
                    color="secondary"
                    @click="dialogNewOffice = true"
                >
                    <v-icon left>
                        mdi-plus
                    </v-icon>
                    Ajouter
                </v-btn>
                <v-dialog
                    v-model="dialogNewOffice"
                    max-width="500px"
                >
                    <v-card>
                        <v-card-title>
                            <span class="headline">Ajout de cabinet</span>
                        </v-card-title>
                         <v-form
                            v-model="isFormValid"
                            ref="newOfficeForm"
                            @submit.prevent="submitNewOfficeForm"
                        >
                        <v-card-text>
                            <v-container>
                                <v-row>
                                    <v-col cols="12" sm="6">
                                        <v-text-field
                                            v-model="newOffice.name"
                                            label="Nom du cabinet"
                                            :rules="[$utils.rules.required]"
                                            :counter="32"
                                        ></v-text-field>
                                    </v-col>
                                    <v-col cols="12" sm="6">
                                        <v-text-field
                                            v-model="newOffice.creator"
                                            label="ID du créateur"
                                            :rules="[$utils.rules.required]"
                                            :counter="8"
                                        ></v-text-field>
                                    </v-col>
                                    <v-col cols="12" sm="12">
                                        <v-text-field
                                            v-model="newOffice.email"
                                            label="Adresse e-mail"
                                            :rules="[$utils.rules.required]"
                                            :counter="64"
                                        ></v-text-field>
                                    </v-col>
                                    <v-col cols="12" sm="6">
                                        <v-text-field
                                            v-model="newOffice.label"
                                            label="Label"
                                            :rules="[$utils.rules.required]"
                                            :counter="94"
                                        ></v-text-field>
                                    </v-col>
                                    <v-col cols="12" sm="6">
                                        <v-select
                                            v-model="newOffice.status"
                                            :items="statusSelectItems"
                                            label="Statut"
                                        ></v-select>
                                    </v-col>
                                    <v-col cols="12" sm="12">
                                        <v-text-field
                                            v-model="newOffice.address"
                                            label="Adresse"
                                            :rules="[$utils.rules.required]"
                                            :counter="94"
                                        ></v-text-field>
                                    </v-col>
                                    <v-col cols="12" sm="6">
                                        <v-text-field
                                            v-model="newOffice.postalCode"
                                            label="Code postale"
                                            :rules="[$utils.rules.required]"
                                            :counter="8"
                                        ></v-text-field>
                                    </v-col>
                                    <v-col cols="12" sm="6">
                                        <v-text-field
                                            v-model="newOffice.city"
                                            label="Ville"
                                            :rules="[$utils.rules.required]"
                                            :counter="64"
                                        ></v-text-field>
                                    </v-col>
                                    <v-col cols="12" sm="6">
                                        <v-text-field
                                            v-model="newOffice.country"
                                            label="Pays"
                                            :rules="[$utils.rules.required]"
                                            :counter="32"
                                        ></v-text-field>
                                    </v-col>
                                    <v-col cols="12" sm="6">
                                        <v-text-field
                                            v-model="newOffice.phoneNumber"
                                            label="Téléphone"
                                            :rules="[$utils.rules.required]"
                                            :counter="64"
                                        ></v-text-field>
                                    </v-col>
                                    <v-col cols="12" sm="6">
                                        <v-text-field
                                            v-model="newOffice.faxNumber"
                                            label="Fax"
                                            :rules="[$utils.rules.required]"
                                            :counter="64"
                                        ></v-text-field>
                                    </v-col>
                                </v-row>
                            </v-container>
                        </v-card-text>
                        <v-card-actions>
                            <v-spacer></v-spacer>
                            <v-btn
                                color="blue darken-1"
                                text
                                @click="dialogNewOffice = false"
                            >
                                Annuler
                            </v-btn>
                            <v-btn
                                color="blue darken-1"
                                type="submit"
                                :disabled="!isFormValid"
                                text
                            >
                                Ajouter
                            </v-btn>
                        </v-card-actions>
                        </v-form>
                    </v-card>
                </v-dialog>
                <v-dialog v-model="dialogDeleteOffice" max-width="500px">
                    <v-card>
                        <v-card-title class="headline">Etes-vous sûr de vouloir supprimer ?</v-card-title>
                        <v-card-actions>
                            <v-spacer></v-spacer>
                            <v-btn color="blue darken-1" text @click="closeDelete">Annuler</v-btn>
                            <v-btn color="blue darken-1" text @click="confirmDeleteOfficeDialog">OK</v-btn>
                            <v-spacer></v-spacer>
                        </v-card-actions>
                    </v-card>
                </v-dialog>
            </v-card-title>
            <v-alert type="info" dismissible class="mx-3" border="left" v-if="(offices.length > 0) && !officesOfPro">
                {{officesOnWaiting && officesOnWaiting.length > 0
                    ? `${officesOnWaiting.length} cabinets sont en attente de validation`
                    : 'Il n\'y a plus de cabinet en attente de validation'
                }}
            </v-alert>
            <v-data-table
                :headers="officeTableHeaders"
                :items="officesOfPro ? officesOfPro : offices"
                :search="search"
                :sort-by.sync="sortBy"
                :items-per-page="itemsPerPage"
                :loading="loading"
                no-results-text="Aucun résultat n'a été trouvé pour votre recherche"	
                no-data-text="Il n'y a pas de données disponibles"	
                loading-text="Les données sont en cours de chargement"
            >   
                <template v-slot:[`item.status`]="{item}">
                    <v-chip
                        dark
                        :color="getStatusWithColor(item.status).color"
                        class="font-weight-bold"
                    >
                        {{ getStatusWithColor(item.status).status }}
                    </v-chip>
                </template>
                <template v-slot:[`item.actions`]="{item}">
                    <v-icon
                        class="mr-2"
                        @click="editOffice(item.id)"
                    >
                        mdi-pencil
                    </v-icon>
                </template>
                
            </v-data-table>
        </v-card>
        <v-snackbar
            v-model="officesSnackbar"
            :timeout="3000"
            :color="snackbarColor"
        >   
            {{snackbarMessage}}
            <template v-slot:action="{ attrs }">
                <v-btn
                    color="white"
                    text
                    v-bind="attrs"
                    @click="officesSnackbar = false"
                >
                    Fermer
                </v-btn>
            </template>
        </v-snackbar>
    </div>
</template>

<script>
import {mapActions, mapGetters} from 'vuex';

export default {
    name: 'Offices',
    props: ['officesOfPro', 'title'],
    data: () => ({
        search: '',
        sortBy: 'status',
        dialogNewOffice: false,
        dialogDeleteOffice: false,
        currentOfficeId: null,
        officesSnackbar: false,
        snackbarColor: '',
        snackbarMessage: '',
        isFormValid: true,
        pageDetail: null,
        loading: false,
        itemsPerPage: 10,
        newOffice: {
            name: '',
            label: '',
            address: '',
            postalCode: '',
            city: '',
            country: '',
            phoneNumber: '',
            faxNumber: '',
            email: '',
            description: '',
            status: null,
            creator: ''
        },
        statusSelectItems: [
            {text: 'Vérifié', value: 1},
            {text: 'En attente', value: 0},
            {text: 'Archivé', value: -1}
        ]
    }),
    methods: {
        ...mapActions(['loadOffices', 'deleteOffice', 'addOffice']),
        editOffice(officeId) {
            this.$router.push({name: 'OfficeDetail', params: {officeId}})
        },
        deleteOfficeDialog(officeId) {
            this.dialogDeleteOffice = true
            this.currentOfficeId = officeId;
        },
        closeDelete() {
            this.dialogDeleteOffice = false;
            this.currentOfficeId = null;
        },
        confirmDeleteOfficeDialog() {
            this.deleteOffice(this.currentOfficeId)
                .then(() => {
                    this.dialogDeleteOffice = false;
                    this.snackbarColor = 'green';
                    this.snackbarMessage = 'L\'établissement a été supprimé avec succès';
                    this.officesSnackbar = true;
                })
                .catch(() => {
                    this.snackbarColor = 'red';
                    this.snackbarMessage = this.getCrudError;
                    this.officesSnackbar = true;
                });
        },
        submitNewOfficeForm() {
            this.newOffice.creator = `/api/users/${this.newOffice.creator}`;
            this.addOffice(this.newOffice)
                .then(() => {
                    this.dialogNewOffice = false;
                    this.snackbarColor = 'green';
                    this.snackbarMessage = 'Le nouveau cabinet a été ajouté avec succès';
                    this.officesSnackbar = true;
                    this.$refs.newOfficeForm.reset();
                })
                .catch(() => {
                    this.snackbarColor = 'red';
                    this.newOffice.creator = '';
                    this.snackbarMessage = this.getCrudError;
                    this.officesSnackbar = true;
                })
        },
        getStatusWithColor(status) {
            if (status === 0) return {color: 'orange', status: 'En attente'}
            else if (status === 1) return {color: 'green', status: 'Vérifié'}
            else return {color: 'red', status: 'Archivé'}
        },
        loadingOffices() {
            if (this.offices === undefined || this.offices.length === 0) {
                this.loading = true;
                this.loadOffices()
                    .then(() => this.loading = false);
            }
        }
    },
    computed: {
        officeTableHeaders() {  
            return [
                {text: 'Nom du cabinet', align: 'start', value: 'name'},
                {text: 'Label', value: 'label'},
                {text: 'Statut', value: 'status'},
                {text: 'Téléphone', value: 'phoneNumber'},
                {text: 'Email', value: 'email'},
                {text: 'Actions', value: 'actions', sortable: false},
            ]
        },
        ...mapGetters(['officesOnWaiting', 'getCrudError', 'offices'])
    },
    mounted() {
        this.loadingOffices();
    }
}
</script>